#!/usr/bin/perl

use strict;

my %users;

foreach my $user (@ARGV) {
    $users{$user}=1;
}

my $gatherDbCols=0;
my @dbColNames;

my @db;

while(<STDIN>) {
    if(/^INSERT INTO `user` VALUES [(](.*)[)]/) {
	foreach my $line (split(/[)],[(]/, $1)) {
	    my @col = split(/,/, $line);
	    next unless($col[1] =~ /'(.*)'/);
	    my $user=$1;
	    if($users{$user}) {
		print "INSERT INTO `user` (host,user,password) values ($col[0], $col[1], $col[2]);\n";
	    }
	}
    }
    if(/^CREATE TABLE `db`/) {
	$gatherDbCols=1;
	next;
    }
    if($gatherDbCols) {
	if(/^\s*`(.*)`/) {
	    push(@dbColNames, $1);
	} else {
	    $gatherDbCols=0;
	}
    }
    if(/^INSERT INTO `db` VALUES [(](.*)[)]/) {
	foreach my $line (split(/[)],[(]/, $1)) {
	    my @col = split(/,/, $line);
	    next unless($col[2] =~ /'(.*)'/);
	    my $user=$1;
	    if($users{$user}) {
		push(@db, "INSERT INTO `db` (".join(",",@dbColNames).
		     ") values ($line);\n");
	    }
	}
    }
}

print join("", @db);

print "FLUSH PRIVILEGES;\n";
